var/Director/sharedDirector

world/tick_lag = 0.5

world/New()
	sharedDirector = new
	..()

atom
	var
		vector/pixloc
		radius = 16
		error = 3
		PixelDensity

	New()
		..()
//		world << "[src] --- ([x],[y])"
		pixloc = new((x-1)*32, (y-1)*32)

	movable

		animate_movement = NO_STEPS

		var
			vector/velocity

		New()
			..()
			SetLocation()
			velocity = new
			sharedDirector.CanMove += src

		Del()
			sharedDirector.CanMove -= src
			..()

		proc
			SetLocation()
				var
					px = pixloc.ComponentX()
					py = pixloc.ComponentY()
					tx = round(px/32)+1
					ty = round(py/32)+1
					pixelx = px % 32// + 16
					pixely = py % 32// + 16
				Move(locate(tx, ty, z))
				pixel_x = pixelx
				pixel_y = pixely
//				world << "Pix: ([px],[py]) --- Tile: ([tx],[ty]) --- Offsets: ([pixelx],[pixely])"

			Update()
				if(velocity.Magnitude() && pixloc)

					var/vector/newloc = pixloc.AddVector(velocity)
					var/list/collided = CollisionCheck(newloc)

					if(collided)
						newloc = collided[2]
						SetLocation()
						PixelBump(collided[1])

					else
						pixloc = newloc
						SetLocation()
						ExtraStuff()

			CollisionCheck(vector/newloc)
				if(!PixelDensity) return

				var
					compx = newloc.ComponentX()
					compy = newloc.ComponentY()

				for(var/atom/A in GetCollidables())

					if(A.PixelDensity)

						var
							deltaX = (compx+error+radius) - (A.pixloc.ComponentX() + A.error + A.radius)
							deltaY = (compy+error+radius) - (A.pixloc.ComponentY() + A.error + A.radius)
							addedRadii = A.radius+radius
							dist = sqrt((deltaX * deltaX) + (deltaY*deltaY))

						if(dist < addedRadii)
							var/list/bumped[2]
							bumped[1] = A
							bumped[2] = pixloc.AddVector(velocity.ScaleToMagnitude(round(dist-addedRadii)))
							return bumped

			PixelBump(atom/A)
				velocity = velocity.Reverse()
				velocity = velocity.Scale(0.5)

			ExtraStuff()

			GetCollidables() return orange(src,2)

Director
	var
		paused = 1
		list/CanMove
		minspeed = -15

	New()
		CanMove = new
		..()
		spawn() Loop()

	proc
		Loop()
			for()
				sleep(world.tick_lag)
				if(!paused)
					for(var/X in CanMove)
						if(!X) continue
						var/atom/movable/A = X
						A.Update()